package controller;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import dispatchers.*;

public class FrontController extends HttpServlet {
  private final HashMap actions = new HashMap();

  //Initialize global variables
  public void init(ServletConfig config) throws ServletException {
    super.init(config);

    actions.put("add_to_cart", new AddToCartAO());
    actions.put("update_cart", new UpdateCartAO());
    actions.put("checkout", new CheckoutAO());
    actions.put("continue", new ContinueShoppingAO());
    actions.put("view_cart", new ViewCartAO());
    actions.put("home", new ShowHomeAO());
   // actions.put("validate_credit", new ValidateCreditAO());


  }

   //Process the HTTP Get request
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    System.err.println("doGet()");
    doPost(request,response);

  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
     response.setContentType("text/html");
     String next_view = "no view ";
     String requestedAction = request.getParameter("action");

     Action ao = null;
     System.err.println("requested action: " + requestedAction);
     if(requestedAction == null) {
      ao  = (Action)(actions.get("home"));
     }
     else{
      ao  = (Action)actions.get(requestedAction);
     }
     next_view = ao.execute(request);
     System.err.println(next_view);
     dispatch(request, response, next_view);
  }
  private void dispatch(HttpServletRequest request, HttpServletResponse response,String page)throws ServletException,
      IOException {
     RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(page) ;
     dispatcher.forward (request, response);
  }


  //Get Servlet information
  public String getServletInfo() {
    return "controller.FrontController Information";
  }
}
