package dispatchers;

import javax.servlet.http.*;
import java.util.*;
import model.Book;
import model.CartItem;


public class AddToCartAO implements Action{
  Map cart = null;
  Book book = null;
  CartItem item =null;
  HttpSession session = null;

  public synchronized String execute(HttpServletRequest request){
    String nextPage = "/jsp/titles.jsp";
    //request.getRequestDispatcher(nextPage).forward(request, response);
    
    session = request.getSession (false);
    cart = (Map)session.getAttribute ("cart");
    String[] selectedBooks = request.getParameterValues("add");

    if(cart == null) {
      cart = new HashMap();
      for(int i=0; i<selectedBooks.length; i++ ) {
        String isbn = selectedBooks[i];
        int quantity = Integer.parseInt(request.getParameter(isbn));
        book = getBookFromList(isbn);
        item = new CartItem(book);
        item.setQuantity (quantity);
        cart.put(isbn,item);
      }  // end for
      session.setAttribute ("cart", cart);
    }   // end if
    else {
      for(int i=0; i<selectedBooks.length; i++ ) {
        String isbn = selectedBooks[i];
        int quantity = Integer.parseInt(request.getParameter(isbn));
        if(cart.containsKey(isbn)) {
          item = (CartItem)cart.get(isbn);
          item.setQuantity (quantity);
        }    // end if
        else{
          book = getBookFromList(isbn);
          item = new CartItem(book);
          item.setQuantity (quantity);
          cart.put(isbn,item);
        } // end else
      } // end for
    } //end else
    return nextPage;
  }  // end execute




  private Book getBookFromList(String isbn) {
    List list = (List)session.getAttribute("books");
    Book aBook = null;
    for(int i=0; i<list.size(); i++) {
      aBook = (Book)list.get(i);
      if(isbn.equals(aBook.getIsbn())){
        break;
      } // end if
    } // end for
    return aBook;
  } // end getBookFromList
}


